<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8">
<title>LibSylph: Sylph/Core/Vector.h Source File</title>
<link href="doxygen.css" rel="stylesheet" type="text/css">
</head><body>
<!-- Generated by Doxygen 1.5.8 -->
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li><a href="classes.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
    </ul>
  </div>
<h1>Sylph/Core/Vector.h</h1><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">/*</span>
<a name="l00002"></a>00002 <span class="comment"> * LibSylph Class Library</span>
<a name="l00003"></a>00003 <span class="comment"> * Copyright (C) 2009 Frank "SeySayux" Erens &lt;seysayux@gmail.com&gt;</span>
<a name="l00004"></a>00004 <span class="comment"> *</span>
<a name="l00005"></a>00005 <span class="comment"> * This library is free software; you can redistribute it and/or</span>
<a name="l00006"></a>00006 <span class="comment"> * modify it under the terms of the LibSylph Pulbic License as published</span>
<a name="l00007"></a>00007 <span class="comment"> * by the LibSylph Developers; either version 1.0 of the License, or</span>
<a name="l00008"></a>00008 <span class="comment"> * (at your option) any later version.</span>
<a name="l00009"></a>00009 <span class="comment"> *</span>
<a name="l00010"></a>00010 <span class="comment"> * This library is distributed in the hope that it will be useful,</span>
<a name="l00011"></a>00011 <span class="comment"> * but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00012"></a>00012 <span class="comment"> * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the LibSylph</span>
<a name="l00013"></a>00013 <span class="comment"> * Public License for more details.</span>
<a name="l00014"></a>00014 <span class="comment"> *</span>
<a name="l00015"></a>00015 <span class="comment"> * You should have received a copy of the LibSylph Public License</span>
<a name="l00016"></a>00016 <span class="comment"> * along with this Library, if not, contact the LibSylph Developers.</span>
<a name="l00017"></a>00017 <span class="comment"> *</span>
<a name="l00018"></a>00018 <span class="comment"> * Created on 6 december 2008, 12:07</span>
<a name="l00019"></a>00019 <span class="comment"> */</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef VECTOR_H_</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define VECTOR_H_</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include "Array.h"</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include "Util.h"</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include "Equals.h"</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include "Iterator.h"</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;initializer_list&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 SYLPH_BEGIN_NAMESPACE
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 SYLPH_PUBLIC
<a name="l00035"></a>00035 
<a name="l00039"></a>00039 <span class="keyword">template</span>&lt;<span class="keyword">class</span> T&gt;
<a name="l00040"></a><a class="code" href="class_sylph_1_1_vector.html">00040</a> <span class="keyword">class </span><a class="code" href="class_sylph_1_1_vector.html">Vector</a> : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_object.html" title="The root of all classes.">Object</a> {
<a name="l00041"></a>00041 <span class="keyword">public</span>:
<a name="l00042"></a>00042     <span class="keyword">class </span>iterator : <span class="keyword">public</span> <a class="code" href="class_sylph_1_1_random_access_iterator.html">RandomAccessIterator</a>&lt;T, iterator&gt; {
<a name="l00043"></a>00043     <span class="keyword">public</span>:
<a name="l00044"></a>00044         <span class="keyword">typedef</span> <a class="code" href="class_sylph_1_1_random_access_iterator.html">RandomAccessIterator&lt;T, iterator&gt;</a> super;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>, <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a>* obj = NULL)
<a name="l00047"></a>00047         : super(begin), _obj(obj) {
<a name="l00048"></a>00048             _currentIndex = begin ? 0 : _obj-&gt;size();
<a name="l00049"></a>00049         }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051         iterator(<span class="keywordtype">bool</span> begin = <span class="keyword">false</span>, <span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a>* obj = NULL)
<a name="l00052"></a>00052         : super(begin), _obj(<span class="keyword">const_cast&lt;</span><a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a>*<span class="keyword">&gt;</span> (obj)) {
<a name="l00053"></a>00053             _currentIndex = begin ? 0 : _obj-&gt;size();
<a name="l00054"></a>00054         }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056         <span class="keywordtype">bool</span> equals(<span class="keyword">const</span> iterator&amp; other)<span class="keyword"> const </span>{
<a name="l00057"></a>00057             <span class="keywordflow">return</span> _currentIndex == other._currentIndex &amp;&amp;
<a name="l00058"></a>00058                     _obj == other._obj;
<a name="l00059"></a>00059         }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061         iterator(<span class="keyword">const</span> iterator&amp; other) {
<a name="l00062"></a>00062             _currentIndex = other._currentIndex;
<a name="l00063"></a>00063             _obj = other._obj;
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066         <span class="keyword">typename</span> super::reference current()<span class="keyword"> const </span>{
<a name="l00067"></a>00067             <span class="keywordflow">return</span> (*_obj)[_currentIndex];
<a name="l00068"></a>00068         }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070         <span class="keywordtype">bool</span> hasNext()<span class="keyword"> const </span>{
<a name="l00071"></a>00071             <span class="keywordflow">return</span> _currentIndex &lt; _obj-&gt;size();
<a name="l00072"></a>00072         }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074         <span class="keywordtype">void</span> next()<span class="keyword"> const </span>{
<a name="l00075"></a>00075             _currentIndex++;
<a name="l00076"></a>00076         }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078         <span class="keywordtype">bool</span> hasPrevious()<span class="keyword"> const </span>{
<a name="l00079"></a>00079             <span class="keywordflow">return</span> _currentIndex &gt;= 0;
<a name="l00080"></a>00080         }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         <span class="keywordtype">void</span> previous()<span class="keyword"> const </span>{
<a name="l00083"></a>00083             _currentIndex--;
<a name="l00084"></a>00084         }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086         idx_t currentIndex()<span class="keyword"> const </span>{
<a name="l00087"></a>00087             <span class="keywordflow">return</span> _currentIndex;
<a name="l00088"></a>00088         }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090         <span class="keywordtype">size_t</span> length()<span class="keyword"> const </span>{
<a name="l00091"></a>00091             <span class="keywordflow">return</span> _obj-&gt;size();
<a name="l00092"></a>00092         }
<a name="l00093"></a>00093     <span class="keyword">private</span>:
<a name="l00094"></a>00094         <span class="keyword">mutable</span> idx_t _currentIndex;
<a name="l00095"></a>00095         <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a>* _obj;
<a name="l00096"></a>00096     };
<a name="l00097"></a>00097     S_ITERABLE(T)
<a name="l00098"></a>00098 <span class="keyword">public</span>:
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keyword">explicit</span> <a class="code" href="class_sylph_1_1_vector.html">Vector</a>(std::size_t initialCount = 16, std::size_t increase = 0) :
<a name="l00101"></a>00101         elements((std::size_t)initialCount), capacityIncrease(increase),
<a name="l00102"></a>00102         elementCount(0) {
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     <a class="code" href="class_sylph_1_1_vector.html">Vector</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; orig) :
<a name="l00106"></a>00106             elements((std::size_t)orig.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>-&gt;length),
<a name="l00107"></a>00107             capacityIncrease(orig.<a class="code" href="class_sylph_1_1_vector.html#834674465858743ca9bc0467f0ecb0d4">capacityIncrease</a>),
<a name="l00108"></a>00108             elementCount(orig.<a class="code" href="class_sylph_1_1_vector.html#ebc75691db23cd76380fb052ce0a5581">elementCount</a>) {
<a name="l00109"></a>00109         arraycopy(orig.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>, 0, elements, 0, orig.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>.length);
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <a class="code" href="class_sylph_1_1_vector.html">Vector</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> &amp; orig) : elements((<span class="keywordtype">size_t</span>)orig.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a> &lt;&lt; 1),
<a name="l00113"></a>00113             elementCount(orig.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a>), capacityIncrease(0){
<a name="l00114"></a>00114         arraycopy(orig, 0, elements, 0, orig.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a>);
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117     <a class="code" href="class_sylph_1_1_vector.html">Vector</a>(<span class="keyword">const</span> std::initializer_list&lt;T&gt; &amp; orig) : elements(orig.size() &lt;&lt; 1),
<a name="l00118"></a>00118             capacityIncrease(0), elementCount(0){
<a name="l00119"></a>00119         <span class="keywordflow">for</span> (T * t = orig.begin(); t &lt; orig.end(); t++) {
<a name="l00120"></a>00120             this-&gt;push(&amp;t);
<a name="l00121"></a>00121         }
<a name="l00122"></a>00122     }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124     <span class="keyword">virtual</span> ~<a class="code" href="class_sylph_1_1_vector.html">Vector</a>() {}
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="comment">// vector specific</span>
<a name="l00127"></a>00127     <span class="keywordtype">void</span> push(<span class="keyword">const</span> T &amp; t) {
<a name="l00128"></a>00128         <span class="keyword">add</span>(t);
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     T pop() {
<a name="l00132"></a>00132         T toReturn = elements[elementCount - 1];
<a name="l00133"></a>00133         elementCount--;
<a name="l00134"></a>00134         <span class="keywordflow">return</span> toReturn;
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     T &amp; <span class="keyword">get</span>(std::size_t idx) {
<a name="l00138"></a>00138         <span class="keywordflow">if</span> (idx &gt;= elementCount) sthrow(<a class="code" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array.">ArrayException</a>, <span class="stringliteral">"Vector out of bounds"</span>);
<a name="l00139"></a>00139         <span class="keywordflow">else</span> {
<a name="l00140"></a>00140             <span class="keywordflow">return</span> elements[idx];
<a name="l00141"></a>00141         }
<a name="l00142"></a>00142     }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keyword">const</span> T &amp; <span class="keyword">get</span>(std::size_t idx) <span class="keyword">const</span> {
<a name="l00145"></a>00145         <span class="keywordflow">if</span> (idx &gt;= elementCount) sthrow(<a class="code" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array.">ArrayException</a>, <span class="stringliteral">"Vector out of bounds"</span>);
<a name="l00146"></a>00146         <span class="keywordflow">else</span> {
<a name="l00147"></a>00147             <span class="keywordflow">return</span> elements[idx];
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <span class="keywordtype">void</span> <span class="keyword">set</span>(std::size_t idx, <span class="keyword">const</span> T &amp; t) {
<a name="l00152"></a>00152         <span class="keywordflow">if</span> (idx &gt;= elementCount) sthrow(<a class="code" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array.">ArrayException</a>, <span class="stringliteral">"Vector out of bounds"</span>);
<a name="l00153"></a>00153         <span class="keywordflow">else</span> {
<a name="l00154"></a>00154             elements[idx] = t;
<a name="l00155"></a>00155         }
<a name="l00156"></a>00156     }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="keywordtype">void</span> trim() {
<a name="l00159"></a>00159         <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> oldElements = elements;
<a name="l00160"></a>00160         elements = <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a>(elementCount);
<a name="l00161"></a>00161         arraycopy(oldElements, 0, elements, 0, elementCount);
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordtype">bool</span> <span class="keyword">add</span>(<span class="keyword">const</span> T &amp; t) {
<a name="l00165"></a>00165         ensureCapacity(elementCount + 1);
<a name="l00166"></a>00166         elements[elementCount] = t;
<a name="l00167"></a>00167         elementCount++;
<a name="l00168"></a>00168         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00169"></a>00169     }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordtype">bool</span> addAll(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; c) {
<a name="l00172"></a>00172     <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> ar = c.<a class="code" href="class_sylph_1_1_vector.html#8c70b369f02f8ffc911e4f097e370c49">toArray</a>();
<a name="l00173"></a>00173     sforeach(T&amp; t, ar) {
<a name="l00174"></a>00174             this-&gt;<span class="keyword">add</span>(t);
<a name="l00175"></a>00175         }
<a name="l00176"></a>00176         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179     <span class="keywordtype">void</span> clear() {
<a name="l00180"></a>00180         elementCount = 0;
<a name="l00181"></a>00181         elements.clear();
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184     <span class="keywordtype">bool</span> contains(T &amp; t)<span class="keyword"> const </span>{
<a name="l00185"></a>00185         <span class="keywordflow">return</span> indexOf(t) != -1;
<a name="l00186"></a>00186     }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordtype">bool</span> containsAll(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; c)<span class="keyword"> const </span>{
<a name="l00189"></a>00189         std::size_t amount = 0;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         sforeach(T &amp; t, c) {
<a name="l00192"></a>00192             <span class="keywordflow">if</span> (this-&gt;contains(t)) amount++;
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194         <span class="keywordflow">return</span> amount == c.<a class="code" href="class_sylph_1_1_vector.html#efeb7063e558297bf95cf9d055cf2d87">size</a>();
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     <span class="keywordtype">bool</span> <a class="code" href="namespace_sylph.html#10c329a0349416d794bedf8f67feb25f" title="Compares the two Arrays on equality.">operator==</a>(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; c)<span class="keyword"> const </span>{
<a name="l00198"></a>00198         <a class="code" href="class_sylph_1_1_vector.html">Vector</a> * v = <span class="keyword">dynamic_cast&lt;</span><a class="code" href="class_sylph_1_1_vector.html">Vector</a><span class="keyword">&gt;</span> (c);
<a name="l00199"></a>00199         <span class="keywordflow">if</span> (v == NULL) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00200"></a>00200         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;size() != c.<a class="code" href="class_sylph_1_1_vector.html#efeb7063e558297bf95cf9d055cf2d87">size</a>()) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00201"></a>00201         <span class="keywordflow">else</span> {
<a name="l00202"></a>00202             <span class="keywordflow">for</span> (std::size_t x = 0; x &lt; c.<a class="code" href="class_sylph_1_1_vector.html#efeb7063e558297bf95cf9d055cf2d87">size</a>(); x++) {
<a name="l00203"></a>00203                 <span class="keywordflow">if</span> (*<span class="keyword">this</span>[x] != c[x]) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00204"></a>00204             }
<a name="l00205"></a>00205             <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209     <span class="keywordtype">bool</span> empty()<span class="keyword"> const </span>{
<a name="l00210"></a>00210         <span class="keywordflow">return</span> size() == 0;
<a name="l00211"></a>00211     }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     <span class="keywordtype">bool</span> <span class="keyword">remove</span>(<span class="keyword">const</span> T &amp; t) {
<a name="l00214"></a>00214         <span class="keywordtype">bool</span> b;
<a name="l00215"></a>00215         (b = indexOf(t) != -1) &amp;&amp; removeAt(indexOf(t));
<a name="l00216"></a>00216         <span class="keywordflow">return</span> b;
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="keywordtype">void</span> removeAt(std::size_t idx) {
<a name="l00220"></a>00220         <span class="keywordflow">if</span> (idx &gt; size()) sthrow(<a class="code" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array.">ArrayException</a>, <span class="stringliteral">"Vector out of bounds"</span>);
<a name="l00221"></a>00221         elementCount--;
<a name="l00222"></a>00222         <span class="keywordflow">if</span> (idx &lt; elementCount)
<a name="l00223"></a>00223             arraycopy(elements, idx + 1, elements, idx,
<a name="l00224"></a>00224                 elementCount - idx);
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227     <span class="keywordtype">bool</span> removeAll(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; c) {
<a name="l00228"></a>00228         std::size_t i;
<a name="l00229"></a>00229         std::size_t j;
<a name="l00230"></a>00230         <span class="keywordflow">for</span> (i = 0; i &lt; elementCount; i++) {
<a name="l00231"></a>00231             <span class="keywordflow">if</span> (c.<a class="code" href="class_sylph_1_1_vector.html#9901427fea025558e45f2e5dba18addd">contains</a>(elements[i])) <span class="keywordflow">break</span>;
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233         <span class="keywordflow">if</span> (i == elementCount) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="keywordflow">for</span> (j = i++; i &lt; elementCount; i++) {
<a name="l00236"></a>00236             <span class="keywordflow">if</span> (!c.<a class="code" href="class_sylph_1_1_vector.html#9901427fea025558e45f2e5dba18addd">contains</a>(elements[i])) elements[j++] = elements[i];
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238         elementCount -= i - j;
<a name="l00239"></a>00239         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00240"></a>00240     }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     <span class="keywordtype">bool</span> retainAll(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; c) {
<a name="l00243"></a>00243         std::size_t i;
<a name="l00244"></a>00244         std::size_t j;
<a name="l00245"></a>00245         <span class="keywordflow">for</span> (i = 0; i &lt; elementCount; i++) {
<a name="l00246"></a>00246             <span class="keywordflow">if</span> (!c.<a class="code" href="class_sylph_1_1_vector.html#9901427fea025558e45f2e5dba18addd">contains</a>(elements[i])) <span class="keywordflow">break</span>;
<a name="l00247"></a>00247         }
<a name="l00248"></a>00248         <span class="keywordflow">if</span> (i == elementCount) <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         <span class="keywordflow">for</span> (j = i++; i &lt; elementCount; i++) {
<a name="l00251"></a>00251             <span class="keywordflow">if</span> (c.<a class="code" href="class_sylph_1_1_vector.html#9901427fea025558e45f2e5dba18addd">contains</a>(elements[i])) elements[j++] = elements[i];
<a name="l00252"></a>00252         }
<a name="l00253"></a>00253         elementCount -= i - j;
<a name="l00254"></a>00254         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00255"></a>00255     }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     std::size_t size()<span class="keyword"> const </span>{
<a name="l00258"></a>00258         <span class="keywordflow">return</span> elementCount;
<a name="l00259"></a>00259     }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261     <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> toArray()<span class="keyword"> const </span>{
<a name="l00262"></a>00262         <span class="keywordflow">return</span> elements;
<a name="l00263"></a>00263     }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265     <span class="comment">// vector specific non-destructive</span>
<a name="l00266"></a>00266 
<a name="l00267"></a>00267     T&amp; front() {
<a name="l00268"></a>00268         <span class="keywordflow">return</span> elements[0];
<a name="l00269"></a>00269     }
<a name="l00270"></a>00270     <span class="keyword">const</span> T &amp; front()<span class="keyword"> const </span>{
<a name="l00271"></a>00271         <span class="keywordflow">return</span> elements[0];
<a name="l00272"></a>00272     }
<a name="l00273"></a>00273     
<a name="l00274"></a>00274     T&amp; back() {
<a name="l00275"></a>00275         <span class="keywordflow">return</span> elements[elementCount - 1];
<a name="l00276"></a>00276     }
<a name="l00277"></a>00277 
<a name="l00278"></a>00278     <span class="keyword">const</span> T &amp; back()<span class="keyword"> const </span>{
<a name="l00279"></a>00279         <span class="keywordflow">return</span> elements[elementCount - 1];
<a name="l00280"></a>00280     }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282     sidx_t indexOf(T &amp; t, std::idx_t idx = 0)<span class="keyword"> const </span>{
<a name="l00283"></a>00283         <span class="keyword">static</span> <a class="code" href="struct_sylph_1_1_equals.html">Equals&lt;T&gt;</a> equf;
<a name="l00284"></a>00284         <span class="keywordflow">for</span> (std::size_t i = idx; i &lt; size(); i++) {
<a name="l00285"></a>00285             <span class="keywordflow">if</span> (equf(*<span class="keyword">this</span>[i], t)) {
<a name="l00286"></a>00286                 <span class="keywordflow">return</span> i;
<a name="l00287"></a>00287             }
<a name="l00288"></a>00288         }
<a name="l00289"></a>00289         <span class="keywordflow">return</span> -1;
<a name="l00290"></a>00290     }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292     <span class="keyword">inline</span> <span class="keywordtype">int</span> lastIndexOf(<span class="keyword">const</span> T &amp; t)<span class="keyword"> const </span>{
<a name="l00293"></a>00293         <span class="keywordflow">return</span> lastIndexOf(t, elementCount);
<a name="l00294"></a>00294     }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     sidx_t lastIndexOf(T &amp; t, std::size_t idx)<span class="keyword"> const </span>{
<a name="l00297"></a>00297         <span class="keyword">static</span> <a class="code" href="struct_sylph_1_1_equals.html">Equals&lt;T&gt;</a> equf;
<a name="l00298"></a>00298         <span class="keywordflow">if</span> (idx &gt; size()) sthrow(<a class="code" href="class_sylph_1_1_array_exception.html" title="A generic Exception when an error occurs with an Array.">ArrayException</a>, <span class="stringliteral">"Vector out of bounds"</span>);
<a name="l00299"></a>00299         <span class="keywordflow">for</span> (std::size_t i = idx; i &gt;= 0; i--) {
<a name="l00300"></a>00300             <span class="keywordflow">if</span> (equf((*<span class="keyword">this</span>)[i], t)) {
<a name="l00301"></a>00301                 <span class="keywordflow">return</span> i;
<a name="l00302"></a>00302             }
<a name="l00303"></a>00303         }
<a name="l00304"></a>00304         <span class="keywordflow">return</span> -1;
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 
<a name="l00307"></a>00307     T &amp; operator[](std::idx_t idx) {
<a name="l00308"></a>00308         <span class="keywordflow">return</span> <span class="keyword">get</span>(idx);
<a name="l00309"></a>00309     }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     <span class="keyword">const</span> T &amp; operator[](std::idx_t idx)<span class="keyword"> const </span>{
<a name="l00312"></a>00312         <span class="keywordflow">return</span> <span class="keyword">get</span>(idx);
<a name="l00313"></a>00313     }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315     <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; operator=(<span class="keyword">const</span> <a class="code" href="class_sylph_1_1_vector.html">Vector&lt;T&gt;</a> &amp; rhs)<span class="keyword"> const </span>{
<a name="l00316"></a>00316         <span class="keyword">delete</span> elements;
<a name="l00317"></a>00317         elements = <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a>(rhs.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>.length);
<a name="l00318"></a>00318         capacityIncrease = rhs.<a class="code" href="class_sylph_1_1_vector.html#834674465858743ca9bc0467f0ecb0d4">capacityIncrease</a>;
<a name="l00319"></a>00319         elementCount = rhs.<a class="code" href="class_sylph_1_1_vector.html#ebc75691db23cd76380fb052ce0a5581">elementCount</a>;
<a name="l00320"></a>00320         arraycopy(rhs.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>, 0, elements, 0, rhs.<a class="code" href="class_sylph_1_1_vector.html#5c91cd558927f8013bea4620e9f7dd17">elements</a>.length);
<a name="l00321"></a>00321         <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323 <span class="keyword">private</span>:
<a name="l00324"></a>00324     std::size_t elementCount;
<a name="l00325"></a>00325     std::size_t capacityIncrease;
<a name="l00326"></a>00326     <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> elements;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328     <span class="keywordtype">void</span> ensureCapacity(std::size_t capacity) {
<a name="l00329"></a>00329         <span class="keywordflow">if</span> (capacity &lt;= elements-&gt;length) <span class="keywordflow">return</span>;
<a name="l00330"></a>00330         std::size_t newsize;
<a name="l00331"></a>00331         <span class="keywordflow">if</span> (capacityIncrease == 0) newsize = elements-&gt;length * 2;
<a name="l00332"></a>00332         <span class="keywordflow">else</span> newsize = elements-&gt;length + capacityIncrease;
<a name="l00333"></a>00333         <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a> oldElements = elements;
<a name="l00334"></a>00334         elements = <a class="code" href="class_sylph_1_1_array.html" title="Array provides a safe array.">Array&lt;T&gt;</a>(newsize);
<a name="l00335"></a>00335         arraycopy(oldElements, 0, elements, 0, oldElements.<a class="code" href="class_sylph_1_1_array.html#b804d99eeea5dd079706490062f196f2" title="The length of the array.">length</a>);
<a name="l00336"></a>00336         <span class="keyword">delete</span> oldElements;
<a name="l00337"></a>00337     }
<a name="l00338"></a>00338 };
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 SYLPH_END_NAMESPACE
<a name="l00341"></a>00341 <span class="preprocessor">#endif  </span><span class="comment">/* VECTOR_H_ */</span>
<a name="l00342"></a>00342 
</pre></div></div>
<hr size="1" class="unhidden"><address style="text-align: right;"><small>
Documentation for LibSylph by Doxygen
</body>
</html>
